/*
 * Data di aggiornamento: 10 Agosto 2012
*/
#include <stdint.h>
#include <math.h>
#include <stdlib.h>

/*
 * Basic: s = MKL$(value)
*/
char* mkl32(uint32_t value)
{
  static char s[4] = {0,0,0,0};
  for (uint8_t n = 0; n < 4; n++)
  {
    s[n] = (char)(value % 256);
    value = value / 256;
  }
  return &s[0];
}

/*
 * Basic: r = CVL(s)
*/
uint32_t cvl32(char *s)
{
  uint32_t r = 0;
  for (uint8_t n = 0; n < 4; n++)
  {
    r = r + (((unsigned char)(s[n])) * pow(256, n));
  }
  return r;
}

/*
 * Basic: RND
*/
inline double aCaso()
{
  return (double)(rand()) / (double)(RAND_MAX);
}

/* Ritorna la stringa corrispondente al valore long passato */
char* itoa(unsigned long val)
{
  static char stringa[32]; stringa[32] = 0;
  if (val == 0) { stringa[31] = '0'; return &stringa[31];}
  char c; short v; bool negativo = false;
  if (val < 0) negativo = true;
  for (v = 31; v >= 0; v--)
  {
    c = (char)(fabs((val % 10)) + 48);
    if (val != 0) stringa[v] = c; else break;
    val = val / 10;
  }
  if (negativo) { stringa[v] = '-'; v--; }
  return &stringa[v + 1];
}
