/* Inizializza una nuova partita */
bool init()
{
  cout << "[I] Init() the game...";
  player.punti = 0;
  player.parziale = 0;
  player.vite = 2;
  player.difficolta = opzione.difficolta;
  lvl = opzione.startLvl;
  boxColor(schermo, 0, 0, 639, 479, 0x000000FF);
  if (! filelvl.is_open()) filelvl.open("livelli.lvl", ios::in | ios::out | ios::binary);
  cout << "[DONE]\n";
  return true;
}

/* Inizializza un nuovo set */
bool begin()
{
  player.x = 320;
  if (opzione.mouse) SDL_WarpMouse(player.x, 239);
  player.lung = 40; /* Metà paddle */
  player.sparaspara = false;
  for (short n = 0; n < n_balls; n++) { palla[n].init(false, false, true); }
  gameinfo.activeBalls = 0;
  if (palla == NULL) { cerr << "[E] Fatal error: no balls created by 'ball* palla = new ball[]'" << endl; return false; }
  /* vedere init() della classe 'ball' per maggiori informazioni*/
  palla[0].init(true, false, true); palla[1].init(false, false, true);
  gameinfo.bonus_percent = 10;
  grafica();
  mouse(false);
  msg("Premi Spazio per iniziare");
  return true;
}

unsigned short qualemusica()
{
  static unsigned short mus;
  //~ if (mus == 2) mus = 1; else mus = 2; /*Sceglie alternativamente la canzone 1 e 2*/
  mus = 1;
  return mus;
}

bool missles_init()
{
  if (SDL_GetTicks() - lasttime.missile >= 100)
  {
    for (short n = 0; n < n_balls; n++)
    {
      if (palla[n].init(true, true))
      {
        lasttime.missile = SDL_GetTicks();
        return true;
        break;
      }
    }
    if (moreballs()) { palla[n_balls - 1].init(true, true); lasttime.missile = SDL_GetTicks(); }
    else { clog << "[W] No new missles initialized in missles_init()" << endl; }
  }
  return false;
}

bool gioca(bool nuovo) {
  if (nuovo)
  {
    if (! init()) { cerr << "[E] Fatal error: unable to init() the game!\n"; return false; }
    if (! begin()) { cerr << "[E] Fatal error: unable to begin() the game!\n"; return false; }
    if (! livello()) return false;
  }
  else
  {
    if (! filelvl.is_open()) filelvl.open("livelli.lvl", ios::in | ios::out | ios::binary);
    if (! carica()) { cerr << "[E] Fatal error: unable to carica() the saved match!\n"; return false; }
    grafica();
    if (! begin()) { cerr << "[E] Fatal error: unable to begin() the game!\n"; return false; }
  }
  if (opzione.sonoro) Mix_Volume(-1, opzione.volumeEffetti); cout << "[I] Mix_Volume() ok\n";

  while (true)
  {
    SDL_PollEvent(&evento);
    switch (evento.type)
    {
      case SDL_KEYDOWN:
        switch(evento.key.keysym.sym)
        {
          case SDLK_RIGHT: player.x = player.x + 0.2 * player.difficolta; break;
          case SDLK_LEFT: player.x = player.x - 0.2 * player.difficolta; break;
          case SDLK_SPACE: if (player.sparaspara) missles_init(); break;
          case SDLK_ESCAPE: if (! salva()) cerr << "[E] Unable to salva() the match!\n"; return true; break;
          case SDLK_s: if (salva()) return true; break;
          case SDLK_p: msg(" -- Pausa -- "); break;
          case SDLK_a:
            scrivi("\a\n"); scrivi("Abbandono del livello"); msg("\a", 1000);
            player.vite--;
            if (player.vite < 0) { gameover(); return true; }
              else { begin(); livello(); }
            break;
          case SDLK_c:
            mouse(true);
            scrivi("\aWaiting for cheat code from stdin\n");
            cout << "[I] Cheat code request has been detected." << endl;
            cout << "Use DEC code values listed in ./data/approfondimenti.txt" << endl;
            cout << "Note: you should use these codes only for testing ad debugging! Code? ";
            short cheatcode; cin >> cheatcode;
            bonus[n_bonus - 1].init(0, cheatcode);
            mouse(false);
            break;
          case SDLK_f:
            if ((SDL_GetVideoSurface()->flags) & SDL_FULLSCREEN) SCHERMOINTERO = 0;
              else SCHERMOINTERO = SDL_FULLSCREEN;
            SDL_SetVideoMode(SCREENWIDTH, 480, DEPTH, SDL_HWSURFACE | SDL_DOUBLEBUF | SCHERMOINTERO);
            msg(" -- Premere Spazio per riprendere il gioco -- ");
            break;
        }
        break;
      case SDL_MOUSEMOTION: if (opzione.mouse) { player.x = evento.motion.x; } break;
      case SDL_MOUSEBUTTONDOWN: if (player.sparaspara && opzione.mouse) missles_init(); break;
      case SDL_ACTIVEEVENT:
        if (! evento.active.gain && opzione.mouse) msg(" -- Pausa -- ");
        break;
      case SDL_QUIT: msg(" -- Pausa -- "); break;
      default: /* OK */; break;
    }

    char muovi[n_balls]; /* Controllo sulle mosse */
    for (short n = 0; n < n_balls; n++)
    {
      muovi[n] = palla[n].muovi();
    }

    for (short n = 0; n < n_balls; n++)
    {
      switch (muovi[n])
      {
        case 'o': /* Ok */ break;
        case 'b':
          if ((aCaso() * 100) < gameinfo.bonus_percent)
          {
            for (short v = 0; v < n_bonus; v++)
              if (bonus[v].init(n)) break;
          }
          break;
        case 'u': /* Oggetto non attivo */ break;
        case 'h':
          suona(1);
          if (player.punti - player.parziale >= 5000)
          {
            player.vite++; player.parziale = player.punti;
            msg("Hai appena guadagnato una vita extra!");
          }
          break;
        case 'l': /* Palla persa. Quante palle attive ci sono? */
          gameinfo.activeBalls--;
          if (gameinfo.activeBalls <= 0)
          {
            gameinfo.activeBalls = 0;
            player.vite--;
            if (! player.perso()) begin(); break;
          }
          break;
        case 'c': /* Livello completato */
          livello();
          if (opzione.autosave) salva(true); /* Salvataggio automatico */
          begin();
          n = n_balls; break;
        default: clog << "[W] Unespected return value " << (int)(muovi[n]) << " = '" << muovi[n] << "' from muovi() in class 'ball', loop #" << n << endl; break;
      }
    }
    for (short n = 0; n < n_balls; n++) { palla[n].controllo(); }
    for (short n = 0; n < n_bonus; n++) { bonus[n].muovi(); }

    switch(player.controllo())
    {
      case 'o': break; /* Overflow (racchetta fuori dallo schermo) */
      case 'l': break; /* Overflow di lunghezza */
      case 'n': break; /* Nothing to do (niente di eccezionale) */
      case 'w': break; /* Il mouse stava uscendo dalla finestra lungo asse Y*/
      default: clog << "[W] Unespected return value from controllo() in class 'giocatore'" << endl; break;
    }
    if (player.perso()) { gameover(); record(); return true; }

    if (opzione.sonoro && ! Mix_PlayingMusic()) Mix_PlayMusic(musica[qualemusica()], 0);

    if (fps()) { grafica(); }
  }
  return true;
}
