bool salva(bool autosave = false)
{
  char salvanome[256];
  strcpy(salvanome, ROOTDIR);
  strcat(salvanome, "partita.ppongsave");
  cout << "[I] Saving the match in " << salvanome << endl;
  fstream file(salvanome, ios::out | ios::binary);
  if (! file.is_open())
  {
    cerr << "[E] Unable to open file to save data of this match!\n";
    cerr << "    Check if ~/.ppong (Linux) or %USERPROFILE%\\ppong (Windows) exists!\n";
    msg("Si e' verificato un errore nel salvataggio, vedere stderr");
    return false;
  }
  file.seekp(0, ios::beg);
  file.write(mkl32(player.punti), 4);
  file.write(mkl32(player.parziale), 4);
  file.write(mkl32(player.vite), 4);
  file.write(mkl32(player.difficolta), 4);
  file.write(mkl32(lvl), 4);

  file.seekp(32, ios::beg);
  for (short y = 0; y < height; y++)
    for (short x = 0; x < width; x++)
      file.put(block[x][y].tipo);

  file.close();
  if (! autosave) msg("Partita salvata!", 3000);
  return true;
}

bool carica()
{
  char salvanome[256];
  strcpy(salvanome, ROOTDIR);
  strcat(salvanome, "partita.ppongsave");
  fstream file(salvanome, ios::in | ios::binary);
  if (file.is_open())
  {
    file.seekg(0, ios::beg);
    char t[4];
    file.read(t, 4); player.punti = cvl32(t);
    if (player.punti == 0)
    {
      file.close();
      cout << "[I] There is no saved game\n";
      msg("Nessuna partita salvata", 10000);
      return false;
    }
    file.read(t, 4); player.parziale = cvl32(t);
    file.read(t, 4); player.vite = cvl32(t);
    file.read(t, 4); player.difficolta = cvl32(t);
    file.read(t, 4); lvl = cvl32(t);

    file.seekg(32, ios::beg);
    for (short y = 0; y < height; y++)
      for (short x = 0; x < width; x++)
      {
        char c; file.get(c);
        if (c > 0) block[x][y].tipo = c; else block[x][y].tipo = c + 256;
      }
    file.close();
    return true;
  }
  else
  {
    cerr << "[E] Unable to open file to load a saved match!\n";
    msg("Impossibile caricare la partita!", 10000);
    return false;
  }
}
